
elevator.MAX_STATIONS_PER_NETWORK = 24

-- set this to true if you want a simulated beam effect
elevator.elevator_effect_enabled = false
-- set this to true if you want a sound to be played when the elevator is used
elevator.elevator_sound_enabled  = false

-- if you set this to false, elevators cannot be created
-- (this may be useful if you want nothing but the elevators on your server)
elevator.elevator_enabled        = true
-- if you set elevator.elevator_enabled to false, you will not be able to
-- craft, place or use elevators
elevator.elevator_enabled         = true
-- if you set this to false, doors will be disabled
elevator.doors_enabled            = true

-- starts an abm which re-adds elevator stations to networks in case the savefile got lost
elevator.abm_enabled              = false

-- change these if you want other receipes for elevator or elevator
elevator.elevator_recipe = {
	{ "default:glass", "default:steel_ingot", "default:glass" },
	{ "default:glass", "default:mese",        "default:glass" },
	{ "default:glass", "default:steel_ingot", "default:glass" }
}
elevator.elevator_recipe = {
	{ "default:steel_ingot", "default:glass", "default:steel_ingot" },
	{ "default:steel_ingot", "",              "default:steel_ingot" },
	{ "default:steel_ingot", "default:glass", "default:steel_ingot" }
}
elevator.tiles_elevator = {
	"elevator_front.png",
	"elevator_panel.png",
	"elevator_outside.png",
	"elevator_ceiling.png",
	"elevator_floor.png",
	"main_block_iron.png"
}
elevator.elevator_inventory_image  = "elevator_elevator_inv.png"

if minetest.registered_nodes["mcl_core:wood"] then
	elevator.elevator_recipe = {
		{ "mcl_stairs:slab_wood",            "mcl_stairs:slab_wood", "mcl_stairs:slab_wood" },
		{ "mesecons_torch:mesecon_torch_on", "mcl_chests:chest",     "mesecons_torch:mesecon_torch_on" },
		{ "mesecons_torch:mesecon_torch_on", "mcl_chests:chest",     "mesecons_torch:mesecon_torch_on" },
		-- { "core:glass",     "mcl_core:iron_ingot",          "mcl_core:glass" },
		-- { "mcl_core:glass", "mesecons_torch:redstoneblock", "mcl_core:glass" },
		-- { "mcl_core:glass", "mcl_core:iron_ingot",          "mcl_core:glass" }
	}
	elevator.elevator_recipe = {
		{ "mcl_stairs:slab_wood", "mcl_stairs:slab_wood", "mcl_stairs:slab_wood" },
		{ "mesecons_torch:mesecon_torch_on", "", "mesecons_torch:mesecon_torch_on" },
		{ "mesecons_torch:mesecon_torch_on", "", "mesecons_torch:mesecon_torch_on" },
		-- { "mcl_core:iron_ingot", "mcl_core:glass", "mcl_core:iron_ingot" },
		-- { "mcl_core:iron_ingot", "",               "mcl_core:iron_ingot" },
		-- { "mcl_core:iron_ingot", "mcl_core:glass", "mcl_core:iron_ingot" }
	}
	elevator.tiles_elevator = {
		"mcl_core_planks_big_oak.png^[transformR90", -- front
		"mcl_core_planks_big_oak.png^[transformR90", -- inside
		"mcl_core_planks_big_oak.png^[transformR90", -- sides outside
		"mcl_core_planks_big_oak.png^[transformR90", -- inside ceiling
		"mcl_core_planks_big_oak.png^[transformR90", -- inside floor
		"mcl_core_planks_big_oak.png^[transformR90", -- top
	}
	elevator.elevator_inventory_image = nil
end

-- if this function returns true, the player with the name player_name is
-- allowed to add a box to the network named network_name, which is owned
-- by the player owner_name;
-- if you want to allow *everybody* to attach stations to all nets, let the
-- function always return true;
-- if the function returns false, players with the elevator_attach priv
-- can still add stations to that network
-- params: player_name, owner_name, network_name
elevator.allow_attach = function()
	return false
end


-- if this returns true, a player named player_name can remove a elevator station
-- from network_name (owned by owner_name) even though he is neither the owner nor
-- has the elevator_remove priv
-- params: player_name, owner_name, network_name, pos
elevator.allow_dig = function()
	return false
end


-- if this function returns false, then player player_name will not be allowed to use
-- the elevator station_name_start on networ network_name owned by owner_name to travel to
-- the station station_name_target on the same network;
-- if this function returns true, the player will be transfered to the target station;
-- you can use this code to i.e. charge the player money for the transfer or to limit
-- usage of stations to players in the same fraction on PvP servers
-- params: player_name, owner_name, network_name, station_name_start, station_name_target
elevator.allow_travel = function()
	return true
end

elevator.elevator_sound_enabled = true
