-- Solid nodes
minetest.register_node("soviet:autowasher", {
	description = "Soviet Auto Washer",
	tiles = 
	{
		"soviet_machine.png",
		"soviet_machine.png",
		"soviet_machine.png",
		"soviet_machine.png",
		"soviet_machine.png",
		"soviet_washer_auto.png"
	},
	paramtype2 = "facedir",
	groups = {cracky = 3},
})

minetest.register_node("soviet:stove", {
	description = "Soviet Gas Stove (DANGEROUS AS FUCK; CAN EXPLODE)",
	tiles = 
	{
		"soviet_stove_top.png",
		"soviet_machine.png",
		"soviet_machine.png",
		"soviet_machine.png",
		"soviet_machine.png",
		"soviet_stove_front.png"
	},
	paramtype2 = "facedir",
	groups = {cracky = 3},
})

minetest.register_node("soviet:concrete", {
	description = "Concrete",
	tiles = {"soviet_concrete.png"},
	is_ground_content = false,
	groups = {cracky = 2},
	sounds = default.node_sound_stone_defaults(),
})

stairs.register_stair_and_slab(
	"concrete",
	"soviet:concrete",
	{cracky = 2},
	{"soviet_concrete.png"},
	"Concrete Stair",
	"Concrete Slab",
	default.node_sound_stone_defaults(),
	true
)

minetest.register_node("soviet:concrete_window", {
	description = "Chunk of Concrete with a Window in it",
	tiles = {"soviet_concrete_window.png"},
	is_ground_content = false,
	groups = {cracky = 2},
	sounds = default.node_sound_stone_defaults(),
})

minetest.register_node("soviet:staircase_flooring", {
	description = "Apt Building Staircase/Lobby Flooring",
	tiles = {"soviet_staircase_flooring.png"},
	is_ground_content = false,
	groups = {cracky = 2},
	sounds = default.node_sound_stone_defaults(),
})

stairs.register_stair_and_slab(
	"staircase_flooring",
	"soviet:staircase_flooring",
	{cracky = 2},
	{"soviet_staircase_flooring.png"},
	"Apt Staircase/Lobby Flooring Stair",
	"Apt Staircase/Lobby Flooring Slab",
	default.node_sound_stone_defaults(),
	true
)

minetest.register_node("soviet:glass",
{
    description = "Glass Mosaic",
    drawtype = "glasslike",
    tiles = {"soviet_glass.png"},
    inventory_image = minetest.inventorycube("soviet_glass.png"),
    paramtype = "light",
	use_texture_alpha = "blend",
    sunlight_propagates = true, 
	sounds = default.node_sound_glass_defaults(),
	is_ground_content = false,
    groups = {cracky = 1},
})

-- Plantlike nodes
minetest.register_node("soviet:laundry_detergent", {
	description = "Laundry Detergent Powder",
	drawtype = "plantlike",
	tiles = {"soviet_laundry_detergent.png"},
	inventory_image = "soviet_laundry_detergent.png",
	wield_image = "soviet_laundry_detergent.png",
	paramtype = "light",
	is_ground_content = false,
	walkable = false,
	selection_box =
	{
		type = "fixed",
		fixed = {-0.25, -0.5, -0.25, 0.25, 0.3, 0.25}
	},
	groups = {dig_immediate = 3, attached_node = 1},
	sounds = default.node_sound_sand_defaults(),
})

minetest.register_node("soviet:tea", {
	description = "Glass of Tea",
	drawtype = "plantlike",
	tiles = {"soviet_tea.png"},
	inventory_image = "soviet_tea.png",
	wield_image = "soviet_tea.png",
	paramtype = "light",
	is_ground_content = false,
	walkable = false,
	selection_box =
	{
		type = "fixed",
		fixed = {-0.25, -0.5, -0.25, 0.25, 0.3, 0.25}
	},
	groups = {dig_immediate = 3, attached_node = 1},
	sounds = default.node_sound_glass_defaults()
})

minetest.register_node("soviet:ceilling_light", {
	description = "Ceilling Light",
	drawtype = "plantlike",
	tiles = {"soviet_lamp.png"},
	inventory_image = "soviet_lamp.png",
	wield_image = "soviet_lamp.png",
	paramtype = "light",
	use_texture_alpha = "blend",
	light_source = 15,
	is_ground_content = false,
	walkable = false,
	groups = {cracky = 1},
	sounds = default.node_sound_glass_defaults(),
})

-- Nodeboxes
minetest.register_node("soviet:light_fixture", {
	description = "Light Fixture",
	tiles = {
		"soviet_light.png",
		"soviet_light.png",
		"soviet_light.png",
		"soviet_light.png",
		"soviet_light.png",
		"soviet_light.png"
	},
	drawtype = "nodebox",
	light_source = 14,
	paramtype2 = "facedir",
	paramtype = "light",
	groups = {cracky = 3},
	node_box = {
		type = "fixed",
		fixed = {
			{-0.1875, -0.125, 0.25, 0.1875, 0.3, 0.5},
		}
	}
})

minetest.register_node("soviet:transradio", {
	description = "Transistor Radio Receiver",
	tiles = {
		"soviet_transradio_top.png",
		"default_wood.png",
		"soviet_transradio_right.png",
		"soviet_transradio_left.png",
		"soviet_transradio_back.png",
		"soviet_transradio_front.png",
	},
	drawtype = "nodebox",
	paramtype = "light",
	paramtype2 = "facedir",
	groups = {cracky = 2},
	node_box = {
		type = "fixed",
		fixed = {
			{-0.375, -0.5, -0.1875, 0.4375, 0, 0.125}, 
			{-0.375, 0, -0.125, -0.1875, 0.0625, -0.0625},
			{-0.1875, 0.0625, -0.125, 0, 0.125, -0.0625}, 
			{0, 0.125, -0.125, 0.1875, 0.1875, -0.0625}, 
			{0.1875, 0.1875, -0.125, 0.375, 0.25, -0.0625}, 
		}
	}
})

minetest.register_node("soviet:concrete_thin", {
	description = "Thin Concrete Wall",
	tiles = {"soviet_concrete.png"},
	is_ground_content = false,
	groups = {cracky = 2},
	sounds = default.node_sound_stone_defaults(),
	paramtype2 = "wallmounted",
	drawtype = "nodebox",
	paramtype = "light",
	node_box = {
		type = "wallmounted",
		fixed = {
			{-0.5, -0.5, 0.4375, 0.5, 0.5, 0.5},
		}
	}
})

minetest.register_node("soviet:concrete_thin_lower", {
	description = "Thin Concrete Wall",
	tiles = {"soviet_concrete.png"},
	is_ground_content = false,
	groups = {cracky = 2},
	sounds = default.node_sound_stone_defaults(),
	paramtype2 = "facedir",
	drawtype = "nodebox",
	paramtype = "light",
	node_box = {
		type = "fixed",
		fixed = {
			{-0.5, .0, 0.4375, 0.5, 0.5, 0.5},
		}
	}
})

minetest.register_node("soviet:concrete_thin", {
	description = "Thin Concrete Wall",
	tiles = {"soviet_concrete.png"},
	is_ground_content = false,
	groups = {cracky = 2},
	sounds = default.node_sound_stone_defaults(),
	paramtype2 = "wallmounted",
	drawtype = "nodebox",
	paramtype = "light",
	node_box = {
		type = "wallmounted",
		fixed = {
			{-0.5, -0.5, 0.4375, 0.5, 0.5, 0.5},
		}
	}
})
